%Chemostat data of the strain K12GAPN+zwf+pPHB 
%June 2018
%%%AEROBIC
clc
close all
clear a* b* c* C* d* D* F* f* l* m* n* o* p* q* s* S* t T V* Y*

V = 1; % Volume of the reactor 
glucose_in = 20/198*1000; % mmol/L
glucose= 20*(180/198) ; %%g/L
Mx = 24.56 ; %%g/mol
MPHB = 86.03;  %%g/mol
% nh4_in =

%% Analysis of the data from TUD36 during the steady state between 
% D = 0.1 h^-1
%% Biomass concentration
biomass_conc= xlsread('TUD36_AEROBIC_miva','CDW','H6:H10');

Cx = mean(biomass_conc); %g/l
SD_bm= std (biomass_conc);

%% Data from the HPLC
%%AVERAGE data 
glucose_out = xlsread('TUD36_AEROBIC_miva','HPLC','E18');  % mmol/L
succinate_out = xlsread('TUD36_AEROBIC_miva','HPLC','F18');  %mmol/L
lactate_out = xlsread('TUD36_AEROBIC_miva','HPLC','G18'); % mmol/L
formate_out = xlsread('TUD36_AEROBIC_miva','HPLC','H18'); % mmol/L
glycerol_out = xlsread('TUD36_AEROBIC_miva','HPLC','I18'); % mmol/L
acetate_out = xlsread('TUD36_AEROBIC_miva','HPLC','J18'); % mmol/L
ethanol_out = xlsread('TUD36_AEROBIC_miva','HPLC','K18'); % mmol/L

%%PHB
PHB_out = xlsread('TUD36_AEROBIC_miva','PHB','H16');  % mmol/L mean
% sd_bmL= (SD_bm-(SD_PHB_out*MPHB)/1000); %% biomass lean (g/L

%% Deviation of the HPLCs data
SD_glucose_out = xlsread('TUD36_AEROBIC_miva','HPLC','E19');  % mmol/L
SD_succinate_out= xlsread('TUD36_AEROBIC_miva','HPLC','F19');  %mmol/L
SD_lactate_out= xlsread('TUD36_AEROBIC_miva','HPLC','G19'); % mmol/L
SD_formate_out= xlsread('TUD36_AEROBIC_miva','HPLC','H19'); % mmol/L
SD_glycerol_out= xlsread('TUD36_AEROBIC_miva','HPLC','I19'); % mmol/L
SD_acetate_out= xlsread('TUD36_AEROBIC_miva','HPLC','J19'); % mmol/L
SD_ethanol_out= xlsread('TUD36_AEROBIC_miva','HPLC','K19'); % mmol/L

SD_PHB_out= xlsread('TUD36_AEROBIC_miva','PHB','H17'); % mmol/L

%For the balance out
t_1 = xlsread('TUD36_AEROBIC_miva','D0.1','C2'); % time (h) From 101.01h to 144.98h
t_2 = xlsread('TUD36_AEROBIC_miva','D0.1','C1261');
out_balance_1 = xlsread('TUD36_AEROBIC_miva','D0.1','G2'); % (kg)
out_balance_2 = xlsread('TUD36_AEROBIC_miva','D0.1','G1261'); % (kg)


%Off-gas Data
data = xlsread('TUD36_AEROBIC_miva','D0.1');
co2_in = data(:,16)/100; % CO2 fraction detected in the pressurized air (PA)
o2_in = data(:,17)/100; % O2 fraction detected in the pressurized air (PA)
atm_P = data(:,6)*100; % atmosferic pressure in Pa

%%Liquid going in


% Correction of the outflow gas
co2_in_corr = co2_in.*100285./atm_P; % Corrected fraction of CO2 at the outflow
o2_in_corr = o2_in.*99603./atm_P; % Corrected fraction of O2 at the outflow 
n2_in = 1 - co2_in_corr - o2_in_corr; % Fraction of N2 at the inflow

% for i = 2:length(t)
%     feed(i-1262) = (out_balance(i)-out_balance(i-1))./(t(i)-t(i-1));
% end

feed = (out_balance_2-out_balance_1)/(t_2-t_1); %  feeding rate (kg/h = L/h)
D = feed/V; % Dilution rate (h^-1)
F_air_in = data(:,12).*60; % Air inflow rate (L/h)
co2_out = data(:,14)./100; % CO2 fraction in the outflow gas
o2_out = data(:,15)./100; % O2 fraction in the outflow gas
T = 37+273; % Temperature of the reactor in K


% Amounts of gas at the inflow
V_m = 8.31*(273+0)/101325*1000; % Volume of  mol of gas in standard conditions (L/mol)
co2_in_flow = co2_in_corr.*F_air_in./V_m*1000; % mmol_co2/h
o2_in_flow = o2_in_corr.*F_air_in./V_m*1000; % mmol_o2/h

% Correction of the outflow gas
co2_out_corr = co2_out.*100285./atm_P; % Corrected fraction of CO2 at the outflow
o2_out_corr = o2_out.*99603./atm_P; % Corrected fraction of O2 at the outflow
n2_out = 1-co2_out_corr-o2_out_corr; % Fraction of N2 at the outflow
F_air_out = F_air_in.*n2_in./n2_out; % Air outflow rate (L/h)

% Amounts of gas at the outflow
co2_out_flow = co2_out_corr.*F_air_out./V_m*1000; % mmol_co2/h
o2_out_flow = o2_out_corr.*F_air_out./V_m*1000; % mmol_o2/h

% Rates of gases mol/h
co2_balance = co2_out_flow-co2_in_flow;
o2_balance = o2_out_flow-o2_in_flow;
co2_balance_mean = mean(co2_balance);
o2_balance_mean = mean(o2_balance);


%% q-rates
q_o2 = o2_balance_mean/Cx/V   % mmmol_O2/g_GDW/h
q_co2 = co2_balance_mean/Cx/V % mmmol_CO2/g_GDW/h
q_BM=(Cx/(24.56/1000)*D)/Cx   %mmol_Cx/g_GDWh
q_glucose = (glucose_out-glucose_in)*D/Cx % mmmol_glucose/g_GDW/h
q_acetate = acetate_out*D/Cx % mmmol_acetate/g_GDW/h
q_succinate = succinate_out*D/Cx % mmmol_glucose/g_GDW/h
q_lactate = lactate_out*D/Cx % mmmol_acetate/g_GDW/h
q_formate = formate_out*D/Cx % mmmol_glucose/g_GDW/h
q_glycerol = glycerol_out*D/Cx % mmmol_acetate/g_GDW/h
q_ethanol = ethanol_out*D/Cx % mmmol_glucose/g_GDW/h
q_PHB = PHB_out*D/Cx % mmmol_PHB/g_GDW/h

%% Yields
Y_gluc_o2 = q_glucose/q_o2
Y_x_gluc = D/q_glucose
Y_BM = (q_BM*Mx)/(q_glucose*180)

%% PHB yield
Y_PHB = (PHB_out*MPHB)/(1000*Cx)*100 ;  % %PHB g/g
YS_PHB = (PHB_out*MPHB)/(1000*glucose) ;  %%  gPHB/gGlucose


%% Respiratory coefficient
RQ= q_co2/q_o2 
rO= q_o2/q_glucose
OUR= q_o2*Cx

%% Standard deviation of the yields and the q-rates;
SD_q_BM = sqrt((SD_bm/Cx)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_BM
SD_q_o2 = sqrt(std((o2_balance)/mean(o2_balance))^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_o2;
SD_q_co2 = sqrt(std((co2_balance)/mean(co2_balance))^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_co2;
SD_q_glucose = sqrt((SD_glucose_out/glucose_in)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_glucose;
SD_q_acetate = sqrt((SD_acetate_out/acetate_out)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_acetate;
SD_q_succinate = sqrt((SD_succinate_out/succinate_out)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_succinate;
SD_q_lactate = sqrt((SD_lactate_out/lactate_out)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_lactate;
SD_q_formate = sqrt((SD_formate_out/formate_out)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_formate;
SD_q_glycerol = sqrt((SD_glycerol_out/glycerol_out)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_glycerol;
SD_q_ethanol = sqrt((SD_ethanol_out/ethanol_out)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_ethanol;
SD_q_PHB = sqrt((SD_PHB_out/ethanol_out)^2+(std(biomass_conc)/mean(biomass_conc))^2)*q_PHB;

RQ_std= sqrt(std((co2_balance)/mean(co2_balance))^2+(std(o2_balance)/mean(o2_balance))^2)*q_co2;

SD_Y_gluc_o2 = sqrt((SD_q_glucose/q_glucose)^2+(SD_q_o2/q_o2)^2)*Y_gluc_o2;
SD_Y_x_gluc = SD_q_glucose*Y_x_gluc;
SD_Y_rO= sqrt((SD_q_o2/q_o2))^2+(SD_q_glucose/q_glucose^2)*rO;
SD_OUR= sqrt((SD_q_o2/q_o2))^2+(SD_bm/Cx^2)*OUR;

rT= [q_o2 q_co2 q_BM q_glucose q_acetate q_lactate q_ethanol q_glycerol q_formate q_succinate q_PHB] ;
SD= [SD_q_o2 SD_q_co2 SD_q_BM SD_q_glucose SD_q_acetate SD_q_lactate SD_q_ethanol SD_q_glycerol SD_q_formate SD_q_succinate  SD_q_PHB];

%%

%Element balances Recovery 95-105%

% %CARBON BALANCE

C_balance = (1*q_BM +  + 2*q_acetate + 4*q_succinate + 3*q_lactate + 1*q_formate + 3*q_glycerol + 2*q_ethanol + 4*q_PHB + 1*q_co2)./ (6*q_glucose) *100 % %C
C_missing = 1-((1*q_BM  + 2*q_acetate + 4*q_succinate + 3*q_lactate + 1*q_formate + 3*q_glycerol + 2*q_ethanol + 1*q_co2)./ (-6*q_glucose));

%%%ELECTRON BALANCE 
E_balance = (4.38*q_BM +  + 8*q_acetate + 14*q_succinate + 12*q_lactate + 2*q_formate + 14*q_glycerol + 12*q_ethanol + 18*q_PHB + (-4*q_o2) )./ (24*q_glucose) *100 % %E
E_missing = 1-((4.38*q_BM  + 8*q_acetate + 14*q_succinate + 12*q_lactate + 2*q_formate + 14*q_glycerol + 12*q_ethanol + (-4*q_o2) )./ (-24*q_glucose))  ;


E_C= E_missing/C_missing ;