%FLUX BALANCE ANALYSIS OF THE STRAIN K12GAPNzwf+pPHB
%PREDICTION FOR DIFFERENT ICL FLUXES
load Ecolicore

mutante=model;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mutante = addReaction(mutante,'ED1',{'6pgc[c]','h2o[c]','KDPG[c]'},[-1 1 1],true,0,20);
mutante = addReaction(mutante,'ED2',{'KDPG[c]','pyr[c]','g3p[c]'},[-1 1 1],true,0,20);

%%%ADDED REACTIONS
%PHB reaction
mutante = addReaction(mutante,'sintPHB',{'accoa[c]','nadph[c]','h[c]','HB[c]','coa[c]','nadp[c]'},[-2 -1 -1 1 2 1],true,0,100);
%GAPN reaction NADPH-dependent
mutante = addReaction(mutante,'GAPN',{'g3p[c]','nadp[c]','h2o[c]','3pg[c]','nadph[c]'},[-1 -1 -1 1 1],true,0,10);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%DELETED REACTIONS
mutante = changeRxnBounds(mutante,'GAPD',0,'b'); %deleting the gene GAPD NADH-dependent
mutante = changeRxnBounds(mutante,'G6PDH2r',0,'b'); %knock-out of the zwf gene
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mutante = changeRxnBounds(mutante,'EX_glc(e)',-2,'l'); %boundary of glucose uptake
%mutante = changeRxnBounds(mutante,'EX_o2(e)',-3.89,'l');
mutante = addExchangeRxn(mutante,{'HB[c]'},-20,20); %export of HB
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
mutante = changeRxnBounds(mutante,'ATPM',4,'l');
mutante = changeRxnBounds(mutante,'Biomass_Ecoli_core_w_GAM',0.1,'b'); %Dilution rate set-up to 0.1

%mutante = changeRxnBounds(mutante,'PPC',0,'b');
%mutante = changeRxnBounds(mutante,'ED1',0.5,'u');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SELECTION OF OBJECTIVE FOR OPTIMIZATION
%mutante = changeObjective(mutante,'Biomass_Ecoli_core_w_GAM');
% mutante = changeObjective(mutante,'ATPM');
mutante = changeObjective(mutante,'EX_glc(e)'); %optimization of glucose uptake rate
%mutante = changeObjective(mutante,'EX_HB[c]');

count=0;
ICL=zeros(39,33);
PHB=zeros(39,33);
UdhA=zeros(39,33);

% ICL=[];
% PHB=[];
% UdhA=[];
for i=0:38

for j=0:16
mutante = changeRxnBounds(mutante,'NADTRHD',i/10,'u');
mutante = changeRxnBounds(mutante,'ICL',j/10,'u');

FBAsolution = optimizeCbModel(mutante,'max');
if FBAsolution.f<0
ICL((i+1),(j+1))=FBAsolution.x(findRxnIDs(mutante,'ICL'));
% qATP(k+1)=FBAsolution.x(findRxnIDs(mutante,'ATPM'));
% ICDH(k+1)=FBAsolution.x(findRxnIDs(mutante,'ICDHyr'));
PHB((i+1),(j+1))=FBAsolution.x(findRxnIDs(mutante,'EX_HB[c]'))*(8.6); %representation of PHB(%)
UdhA((i+1),(j+1))=FBAsolution.x(findRxnIDs(mutante,'NADTRHD'));

% scatter3(ICL,UdhA,PHB);
% hold on
count=count+1;
end

end
end


%FBAsolution = optimizeCbModel(mutante,'min');
% FBAsolution.x;
% printFluxVector(mutante,ans,1,1);

%clear mutant ans lista lista1 lista2 reacciones maximos minimos rxnID wildtype figureHandle carteles flujos hFig i img k s maxFlux minFlux   valores l rxnIDMET listaMET 