%FLUX BALANCE ANALYSIS OF THE STRAIN K12GAPNzwf+pPHB
%Oxygen Limited state

load Ecolicore
clear mutante listaMET rxnIDMET l flujosMET
mutante=model;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mutante = addReaction(mutante,'ED1',{'6pgc[c]','h2o[c]','KDPG[c]'},[-1 1 1],true,0,0);
mutante = addReaction(mutante,'ED2',{'KDPG[c]','pyr[c]','g3p[c]'},[-1 1 1],true,0,0);

%%%ADDED REACTIONS
%PHB reaction
mutante = addReaction(mutante,'sintPHB',{'accoa[c]','nadph[c]','h[c]','HB[c]','coa[c]','nadp[c]'},[-2 -1 -1 1 2 1],true,0,100);
%GAPN reaction NADPH-dependent
mutante = addReaction(mutante,'GANP',{'g3p[c]','nadp[c]','h2o[c]','3pg[c]','nadph[c]','h[c]'},[-1 -1 -1 1 1 2],true,0,20);

%DELETED REACTIONS
mutante = changeRxnBounds(mutante,'GAPD',0,'b'); %deleting the gene GAPD NADH-dependent
mutante = changeRxnBounds(mutante,'G6PDH2r',0,'b'); %knock-out of the zwf gene

%mutante = addReaction(mutante,'transporter',{'glc_D[e]','glc[c]'},[-1 1],true,0,20);
%mutante = addReaction(mutante,'XYLISO',{'fru[c]','glc[c]'},[-1 1],true,0,0);
%mutante = addReaction(mutante,'HEXKin1',{'fru[c]','atp[c]','f6p[c]','adp[c]','h[c]'},[-1 -1 1 1 1],true,0,20);
%wildtype={'nadp[c]';'nadph[c]'};
%mutant={'nad[c]';'nadh[c]'};
%mutante = changeRxnMets(mutante,wildtype,mutant,'G6PDH2r');
%mutante = addReaction(mutante,'NADG6PDH',{'g6p[c]','nad[c]','nadh[c]','6pgl[c]','h[c]'},[-1 -1 1 1 1],true,0,10);
mutante = addExchangeRxn(mutante,{'HB[c]'},0,20);

% mutante = addExchangeRxn(mutante,{'gluconate[c]'},0,0);
% mutante = addReaction(mutante,'gluconateKinase',{'gluconate[c]','atp[c]','6pgc[c]','adp[c]' },[-1 -1 1 1],true,0,10);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%mutante = changeRxnBounds(mutante,'EX_ac(e)',-10,'l');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

%%CONSTRAINTS added
mutante = changeRxnBounds(mutante,'EX_glc(e)',-2.0,'u');
mutante = changeRxnBounds(mutante,'EX_o2(e)',-6.0,'u');
mutante = changeRxnBounds(mutante,'ICL',1.6,'u');
mutante = changeRxnBounds(mutante,'NADTRHD',3.8,'u');
%mutante = changeRxnBounds(mutante,'THD2',0,'b');
%mutante = changeRxnBounds(mutante,'PGI',0,'u');
%mutante = changeRxnBounds(mutante,'GND',0,'b');  
mutante = changeRxnBounds(mutante,'Biomass_Ecoli_core_w_GAM',0.1,'b');
mutante = changeRxnBounds(mutante,'ATPM',4.0,'l'); %%as reported by Hilal in mmol/g/h
% mutante = changeRxnBounds(mutante,'ICDHyr',4,'l');
 


% NAD={'nad[c]';'nadh[c]'};
% NADP={'nadp[c]';'nadph[c]'};
% mutante = changeRxnMets(mutante,NADP,NAD,'ICDHyr');
%mutante = changeRxnMets(mutante,NADP,NAD,{'G6PDH2r'});


%mutante = addReaction(mutante,'NADPH_respiration',{'h[c]','nadph[c]','q8[c]','h[e]','nadp[c]','q8h2[c]'},[-4 -1 -1 3 1 1],true,0,20);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% lista das reacoes que se quer representar graficamente

% reacciones = {'EX_glc(e)','PGI','FBA','G6PDH2r','GND','RPE','RPI','TKT1','TKT2','GAPD','PDH','CS','ICDHyr','AKGDH','FUM','MDH','ME1','ME2','PPCK','ICL','ATPS4r','EX_ac(e)','THD2','NADTRHD','PPC','ED1','sintPHB','Biomass_Ecoli_core_w_GAM','PFL','EX_lac_D(e)','TALA','ATPM'};
reactions = {'ACALD'	'ACALDt'	'ACKr'	'ACONTa'	'ACONTb'	'ACt2r'	'ADK1'	'AKGDH'	'AKGt2r'	'ALCD2x'	'ATPM'	'Biomass_Ecoli_core_w_GAM'	'CO2t'	'CS'	'CYTBD'	'D_LACt2'	'ENO'	'EX_ac(e)'	'EX_acald(e)'	'EX_akg(e)'	'EX_co2(e)'	'EX_etoh(e)'	'EX_for(e)'	'EX_fru(e)'	'EX_fum(e)'	'EX_glc(e)'	'EX_gln_L(e)'	'EX_glu_L(e)'	'EX_h(e)'	'EX_h2o(e)'	'EX_lac_D(e)'	'EX_mal_L(e)'	'EX_nh4(e)'	'EX_o2(e)'	'EX_pi(e)'	'EX_pyr(e)'	'EX_succ(e)'	'FBA'	'FBP'	'FORt2'	'FORti'	'FRD7'	'FRUpts2'	'FUM'	'FUMt2_2'	'G6PDH2r'	'GAPD'	'GLCpts'	'GLNS'	'GLNabc'	'GLUDy'	'GLUN'	'GLUSy'	'GLUt2r'	'GND'	'H2Ot'	'ICDHyr'	'ICL'	'LDH_D'	'MALS'	'MALt2_2'	'MDH'	'ME1'	'ME2'	'NADH16'	'NADTRHD'	'NH4t'	'O2t'	'PDH'	'PFK'	'PFL'	'PGI'	'PGK'	'PGM'	'PIt2r'	'PPC'	'PPCK'	'PPS'	'PTAr'	'PYK'	'PYRt2r'	'RPE'	'RPI'	'SUCCt2_2'	'SUCCt3'	'SUCDi'	'SUCOAS'	'TALA'	'THD2'	'TKT1'	'TKT2'	'TPI'	'PGL'	'ATPS4r'	'ETOHt2r'	'ED1'	'ED2'	'sintPHB'	'GANP'	'EX_HB[c]'};
rxnID = findRxnIDs(mutante,reactions);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SELECCION DEL OBJETIVO Y EJECUCION DEL PROCEDIMIENTO DE OPTIMIZACION
% mutante = changeObjective(mutante,'Biomass_Ecoli_core_w_GAM');
% mutante = changeObjective(mutante,'ATPM');
% mutante = changeObjective(mutante,'EX_gluconate[c]');
mutante = changeObjective(mutante,'EX_glc(e)')
% mutante = changeObjective(mutante,'EX_o2(e)')
% mutante = changeObjective(mutante,'EX_ac(e)')
%mutante = changeObjective(mutante,'sintPHB');

for i=0:70
    
% 
% for j=1:10
% 
% mutante = changeRxnBounds(mutante,'EX_ac(e)',-j,'b');
mutante = changeRxnBounds(mutante,'EX_o2(e)',-i/10,'b');
% mutante = changeRxnBounds(mutante,'EX_glc(e)',-i/10,'b');
FBAsolution = optimizeCbModel(mutante,'max');
% if FBAsolution.f
% FBAsolution.x;
% 
% printFluxVector(mutante, FBAsolution.x,1,1);
% 
% end
% glucose(i,j)=i;
% acetate(i,j)=j;
if FBAsolution.f
 FBAsolution.x;
printFluxVector(mutante, FBAsolution.x,1,1);   
    
PHB(i+1)=FBAsolution.x(findRxnIDs(mutante,'EX_HB[c]'))*86;
RATE_PHB(i+1)=FBAsolution.x(findRxnIDs(mutante,'EX_HB[c]'));
qo2(i+1)=-1*FBAsolution.x(findRxnIDs(mutante,'EX_o2(e)'));
ICL(i+1)=FBAsolution.x(findRxnIDs(mutante,'ICL'));
qATP(i+1)=FBAsolution.x(findRxnIDs(mutante,'ATPM'));
ICDH(i+1)=FBAsolution.x(findRxnIDs(mutante,'ICDHyr'));
UdhA(i+1)=FBAsolution.x(findRxnIDs(mutante,'NADTRHD'));
qS(i+1)=FBAsolution.x(findRxnIDs(mutante,'EX_glc(e)'));
% qO2overqS((i+1),(j+1))=qS((i+1),(j+1))/qO2((i+1),(j+1));
end
end

Ratio= (qo2./qS)*-1;
Ratio_PHB = (PHB./qS)*-1;

figure()
plot(Ratio,PHB,'b','LineWidth',2)
hold on
plot(Ratio,ICDH,'m','LineWidth',2)
hold on
plot(Ratio,ICL,'g','LineWidth',2)
% hold on
% plot(Ratio,qATP,'r')
hold on
plot(Ratio,UdhA,'k','LineWidth',2)
xlabel('O_2/S') % x-axis label
ylabel('(mmol/gCDW h)/PHB(%)') % y-axis label
% legend('PHB','ICL','UdhA')
legend('PHB','ICDH','ICL','UdhA')

figure()
plot(qo2,PHB,'b','LineWidth',2)
hold on
plot(qo2,ICDH,'k','LineWidth',2)
hold on
plot(qo2,ICL,'g','LineWidth',2)
hold on
plot(qo2,qATP,'r','LineWidth',2)
hold on
plot(qo2,UdhA,'c','LineWidth',2)
xlabel('oxygen uptake (mmol/gCDW h)') % x-axis label
ylabel('(mmol/gCDW h)/PHB(%)') % y-axis label
legend('PHB','ICDH','ICL','ATP')


%printFluxVector(mutante,ans,1,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Salvando os fluxos

for i=1:length(rxnID)
     
     flujos(i)=FBAsolution.x(rxnID(i));
    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% listaMET = findRxnsFromMets(mutante,'nadph[c]');
% rxnIDMET=findRxnIDs(mutante,listaMET);
% 
% for l=1:length(listaMET)
%     flujosMET(i)=FBAsolution.x(rxnIDMET(i));
%     valores(i)=rxnIDMET(i);
% end
% 
% flujosMET=flujosMET';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% CAPTURA DA IMAGEM
% img = imread('fluxmap2.png');
% hFig = figure;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SUPRIME APARICION DE UN WARNING
% s = warning('off', 'Images:initSize:adjustingMag');
% imshow(img, 'InitialMagnification',100, 'Border','tight')
% warning(s);
%image(img);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CONVERSAO DOS VALORES NUMERICOS DOS FLUXOS EN CARACTERES PARA SEREM
% IMPRESSOS
% 
% for i = 1:length(reacciones)
%     
%     carteles{i} = num2str(sprintf('%g',round(flujos(i)*100)/100)); 
% 
% end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% COMANDOS PARA CONSEGUIR A IMPRESSAO DOS FLUXOS ACIMA DA FIGURA

% for i=1:length(reacciones)
% text(valorx(i),valory(i),carteles(i));
% end
% 
% text(585,15,'growth rate (1/h)');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TROCANDO AS PROPRIEDADES DOS TEXTOS QUE SAEM NA FIGURA

% figureHandle = gcf;
% 
% set(findall(figureHandle,'type','text'),'Color','black','fontSize',14,'fontWeight','bold');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Apagando TODAS AS VARIAVEIS TEMPORAIS QUE NAO INTERESA CONSERVAR
% clear mutant ans lista lista1 lista2 reacciones maximos minimos rxnID wildtype figureHandle carteles flujos hFig i img k s maxFlux minFlux  FBAsolution
% mutante valores l rxnIDMET listaMET flujosMET